#include <REG938.H>
#include <Encoder_Lib.h>

static unsigned char ucActEncVal;
char cValue;

void v_InitEncoder(void)
{
   ucActEncVal = P0 & 0xA0;  // Abspeichern der akt. Position
   cValue = 0;               // Ruecksetzen 

   KBPATN = P0 & 0xE0;       // Setzen des Keyboard-Patterns
   KBCON = 0x00;
   KBMASK = 0xE0;  // Maske fuer Portpin 5, 6 und 7
   EKBI = 1;     // ISR fuer Keyboard-Int. freigeben
}

void v_KeyboardInt(void) interrupt 7
{
   KBPATN = P0 & 0xE0; // Neues Keyboard-Pattern setzen

   if (ucActEncVal != (P0 & 0xA0)) // Abfrage, ob Aenderung beim
   {                               // Inkrementalgebers erfolgt ist 
      switch(P0&0xA0)
      {
      case 0x00:
         if (ucActEncVal == 0x20)
           cValue++;
         else
           cValue--;
         break;
      case 0x20:
         if (ucActEncVal == 0xA0)
           cValue++;
         else
           cValue--;
         break;
      case 0x80:
         if (ucActEncVal == 0x00) 
           cValue++;
         else
           cValue--;
         break;
      case 0xA0:
         if (ucActEncVal == 0x80)
           cValue++;
         else
           cValue--;
         break;
      }
      ucActEncVal = P0 & 0xA0;  // Abspeichern der neuen Positon
   }                            // des Inkrementalgebers
   KBCON = 0x00;                // Loeschen des Keyboard Flags
}