;***************************************************************
; Modulname:    $Source: $
; User:         $Author: $
; Version:      $Name: $  $Revision: $
; Datum:        $Date: $
; Qualitt:     $State: $
;***************************************************************
; Beschreibung:
; Die Funktion v_Itoa() konvertiert einen Integerwert in einen
; ASCII-Wert. Als Wandlung steht Binr(2), BCD(10) und HEX(16)
; zur Verfgung.
;*************************************************************** 
; Verwendete Register:
; R0-R7, A, B
;***************************************************************
; Funktionsaufruf in C51:
;  extern void extern void v_Itoa(int iValue, char cRadix, char *pcStr);
;***************************************************************
; Historie:
;==========
; $Log: $
;***************************************************************
; Definitionen
;***************************************************************
$REGUSE _v_Itoa(A, B, R0- R7)
NAME	ITOA

?PR?_v_Itoa?ITOA       SEGMENT CODE
        EXTRN   CODE (_ui_Hex2Bcd)
	EXTRN	CODE (?C?CSTPTR)
	PUBLIC	_v_Itoa

	RSEG  ?PR?_v_Itoa?ITOA
	USING	0
_v_Itoa:
        PUSH PSW
        CLR  F0
	MOV  A,R5        ; Abfrage des Radix
      JB ACC.4, BASE_16  ; ist Radix == 16
      JB ACC.3, BASE_10  ; ist Radix == 10
                         ; ansonsten Radix == 2
;***************************************************************
; HEX -> ASCII-BIN Konvertierung 
; Version 1.1  Datum 28.09.98   User: MEBA
;***************************************************************
        CLR  C           ; Die Datengewinnung erfolgt ber Rota-
        MOV  R0, #16     ; tion vom Integerwert. In R0 wird die
LINKS_NORMIERUNG:        ; Anzahl der mglichen Rotationen abge-
CHANGE_HEX2BIT:          ; speichert.
        MOV  A, R7       ; lade LSB
        RLC  A           ; schiebe LSB nach links durch Carry
        MOV  R7, A       ; speichere LSB
        MOV  A, R6       ; Lade MSB
        RLC  A           ; schiebe MSB nach links durch Carry
        MOV  R6, A       ; speichere MSB
      JC FIRST_BIT_FOUND ; Auswertung ob eine 1 gefunden wurde
      JNB F0, NEXT_ROTATION ; In F0 wird abgespeichert, ob schon
FIRST_BIT_FOUND:         ; eine Linksnormierung stattgefunden hat.
        SETB F0          ; Ist dies der Fall, so wird F0 gesetzt.
        CLR  A           ; Wandlung binr nach ASCII
	ADDC A,#30H      ;
      ACALL  SAVE_RESULT ; Abspeicherung vom Ergebnis
NEXT_ROTATION:
      DJNZ   R0, CHANGE_HEX2BIT
      JMP   NULL_BYTE_SAVE ; Nullterminierung anhngen
;***************************************************************
; HEX -> ASCII-BCD Konvertierung 
; Version 1.2  Datum 28.09.98   User: MEBA
; Bugfix:
; Bei negativen Zahlen gab es bei LSB = 0 (Zweierkomplement) kein
; MSB bertrag.
; Bei Zahlen > 25599 wurde das MSB nicht korrekt weitergezhlt.
;***************************************************************

BASE_10:
        MOV  A, R6
      JNB ACC.7, NO_MINUS   ; berprfung auf negatives Vorzeichen
        CPL  A              ; Einerkomplement
        MOV  R6, A          ; bilden fr MSB
        MOV  A, R7          ; Zweierkomplement bilden
        CPL  A              ; fr LSB
        INC  A
        MOV  R7, A
       JNZ MINUS_AUSGEBEN
        INC  R6
MINUS_AUSGEBEN: 
        MOV  A,#'-'         ; negatives Vorzeichen abspeichern
      ACALL  SAVE_RESULT    ; im Array als erstes Zeichen
NO_MINUS:  
        MOV  R5, #0         ; LSB von HEX nach BCD Konvertieren. Da
        MOV  A, R6          ; das Ergebnis in R6/R7 liegt mu das
        MOV  R4, A          ; MSB in R4 zwischengespeichert werden
      ACALL _ui_Hex2Bcd        ;

        MOV  A, R4          ; Auswertung vom MSB
      JZ AUSGABE            ; Ist MSB == 0
        MOV  A, R7          ; BCD-LSB in Accu laden 
;---------------------------------------------------------------------
KORREKTUR_MSB:
                            ; Addition von 256(Dezimal) auf LSB-Anteil
        ADD  A, #56H        ; BCD-LSB Korrektur um den MSB-Anteil
        DA   A
        MOV  R0, A
        MOV  A, R6
       JNC  KORREKTUR_2     ; Ist nach der BCD Korrektur ein berlauf
        ADD  A, #3          ; entstanden ? MSB-LSB erhhen
       SJMP  MSB_SAVE
KORREKTUR_2:
        ADD  A, #2          ; Erhhung vom MSB-Wert
MSB_SAVE:
        MOV R6, A           ;
       JNC  NEXT_ROUND
        INC R5              ; Der Wert fr die erste Stelle
NEXT_ROUND:     
        MOV  A, R0
      DJNZ R4, KORREKTUR_MSB; Weiter 256er Korrekturen notwendig ? 
;---------------------------------------------------------------------
        PUSH ACC              ; LSB-Speichern
        MOV  A, R6          ; MSB in BCD wandeln
        MOV  R7, A          ; 
      ACALL _ui_Hex2Bcd 

        MOV  A, R5          ; Abfrage ob Werte > 25999 vorliegen
       JZ  AUSGABE_VORBEREITEN
        MOV  A, R7     
;---------------------------------------------------------------------
KORREKTUR_MSB2:
        ADD  A, #56H        ; BCD-LSB Korrektur um den MSB-Anteil
        DA   A
       JNC  KORREKTUR_2MSB  ; Ist nach der BCD Korrektur ein berlauf
        INC  R6             ; entstanden ? MSB-LSB erhhen
KORREKTUR_2MSB:
        INC  R6             ; Erhhung vom MSB-Wert
        INC  R6
      DJNZ R5, KORREKTUR_MSB2; Weiter 256er Korrekturen notwendig ? 
        MOV  R7, A
AUSGABE_VORBEREITEN:    
             
        MOV  A, R7          ; Das Gesamtergebniss liegt MSB in R5 
        XCH  A, R6          ; und LSB in R7

        XCH  A, R5
        POP  ACC
        MOV  R7, A   
Ausgabe:
        MOV  R4, #6         ; Anzahl auszuwertender Nibbles
        MOV  R0, #5         ; Startadresse Auswertung im Register
      SJMP  CHANGE_BEGIN

;***************************************************************
; HEX -> ASCII-HEX Konvertierung 
; Version 1.1  Datum 28.09.98   User: MEBA
;***************************************************************

BASE_16:  
        MOV  R4, #4         ; Anzahl auszuwertender Nibbles
        MOV  R0, #6         ; Startadresse Auswertung im Register

CHANGE_BEGIN:
        CLR  F0             ; F0 dient zur Anzeige vom Nibbletausch
        MOV  B, #0          ; B dient zur Anzeige ob eine Links-
CHANGE_HEX2ASCII:           ; normierung stattfand.
        MOV  A, @R0         ; Wert laden
      JB  F0, NO_SWAP       ; Soll Nibbletausch stattfinden ?
        SWAP A              ; Nibbles tauschen
        SETB F0             ; Zeiger setzen
      SJMP CHANGE_IT 
NO_SWAP:   
        CLR  F0             ; Zeiger lschen
CHANGE_IT:
        ANL  A,#0FH         ; Auswertung vom unteren Nibble
        CLR  C
        SUBB A, #0AH        ; Subtraktion um 10 zur berprfung
     JC CHAR_0_9            ; ob es ein Zeichen zwischen 0 und 9 ist
        ADD  A, #07H        ; das Zeichen liegt im Bereich von A - F
CHAR_0_9:
        ADD  A, #03AH       ; Korrektur auf ASCII-0
      CJNE   A, #'0', CHAR_FOUND ; Zahl > 0
        XCH  A, B           ; Abfrage ob Linksnormierung stattfand
       JNZ   NO_FIRST_ZERO  ;     
        XCH  A, B           ; Linksnormierung hat noch nicht statt-
      SJMP   LOAD_NEXT_VALUE; gefunden 
NO_FIRST_ZERO:
        XCH  A, B           ; Linksnormierung hat stattgefunden
CHAR_FOUND:
        INC  B  
CHAR_0:
      ACALL SAVE_RESULT     ; Umgewandeltes Zeichen im Array abspeichern
LOAD_NEXT_VALUE:
        MOV  A, @R0         ; Zeichen laden 
      JB F0, NEXT
        INC  R0             ; Falls unteres Libble ausgewertet wird,
NEXT:                       ; Datenzeiger verstellen.
      DJNZ R4, CHANGE_HEX2ASCII
;***************************************************************
; Anhngen einen \0 an den String zur Endekennung
;***************************************************************

NULL_BYTE_SAVE:             ; Der String mu abschlieend mit 
        CLR A               ; einem Nulldeterminierung versehen
      ACALL SAVE_RESULT     ; werden
        POP PSW             ; altes PSW wieder herstellen
	RET  	
;***************************************************************
; Abspeichern vom Resultat im angegebenen Array
;***************************************************************
SAVE_RESULT:
      LCALL  ?C?CSTPTR      ; Abspeicherung eines Char-Wert mit
	MOV  A,#01H         ; einem generic Pointer
	ADD  A, R1          ; Incrementierung des Pointers um 1.
	MOV  R1,A           ;
      JNC NO_MSB_KORREKTUR  ; Kein MSB-Overflow
	INC  R2             ; Inkrementiere MSB
NO_MSB_KORREKTUR:
      RET  


	END
