//#include <reg51.h>
#include <REG936.H>
#include <Encoder_Lib.h>
#include <PortConfig.H>
#include <lcd_def.h>
#include <stdio.h>
#include <conio.h>

void Timer_1_ISR(void);      //Prototypen-Anmeldung
void del_10ms(unsigned char x);
void zeit_s(void);
void zeit_l(void);
void lcd_com(void);
void lcd_ein(void);
void lcd_ini1(void);
void switch_z1(void);
void switch_z2(void);
void show_text(char *ptr);
void cv_ascii(char *ptr2,char *ptr3);
void bit_ausw(char *ptr4);
void cv_zeit(char *ptr5);
void cv_date(char *ptr6,char *ptr7);

sbit PULS_EING=P0^5;//0xB2;     //Uhrenausgang an Pin P3.2
sbit SEK= P0^1;//0xB3 ;          //Sekunden-LED an Pin P3.3
sbit ZER_ONE= P0^2;//0xB4;       //Datenbit-LED an Pin P3.4
sbit GAP= P0^3;//0xB5;           //Minuten-Lcken-LED an Pin P3.5

bit  phase_1;
bit  phase_2;
bit  phase_3;

 unsigned char data TIM_TICK=0;
 unsigned char data SEK_TICK=0;


 unsigned char data MIN_EINS=0;
 unsigned char data MIN_ZEHN=0;

 unsigned char data STD_EINS=0;
 unsigned char data STD_ZEHN=0;


 unsigned char data TAG_EINS=0;
 unsigned char data TAG_ZEHN=0;

 unsigned char data WOCH_TAG=1;

 unsigned char data MON_EIN=0;
 unsigned char data MON_ZEH=0;

 unsigned char data JAHR_EIN=0;
 unsigned char data JAHR_ZEH=0;

unsigned char code start1a[21]= {"Projekt Funkuhr "};
unsigned char code start1b[21]= {"Minutenerkennung    "};
unsigned char code phase_2a[21]={"Luecke erkannt!     "};
unsigned char code sterne[21]=  {"********************"};
unsigned char code loeschz[21]= {"                    "};
unsigned char code wochent[15]= {"MoDiMiDoFrSaSo"}; 
/*----------------------------------------------------------*/

void main(void)
{   
 	char lcd_zeit[21]=     {"Zeit:     00:00:00  "};
	char lcd_date[21]=     {"Datum: Mo 17.01.2000"};
//   v_PortConfig(Port2, AllPins, BiDir);
	P0M1=0x10;
	P0M2=0x10;
 	P2M1=0x00;
	P2M2=0x00;
 	phase_1=1;
	phase_2=0;
	phase_3=0;
	TIM_TICK=0;
	SEK_TICK=0;
	uc_LCDIni(_2LINE | _7DOTS);

	TMOD=0x10;	     //Timer1 als 16 Bit -Timer (Mode 1)
	TL1=0xEF;            //Reloadwerte fr
	TH1=0xD8;            //10ms-Tick
	ET1=1;               //Timer1 - Interrupt freigeben
	PT1=0x08;             //Timer 1 auf hchste Prioritt
	
//	P3=0xFF;             //Port 3 auf Lesen schalten
P0=0xFF;
  
 	TF1=0;               //Timer1-berlaufflag vorsichtshalber lschen
      	EA=1;                //Interrupts freigeben
        GAP=0;               //Lckenanzeige lschen
        TR1=0;		     //Timer garantiert ausgeschaltet
	   
	 	uc_Clrscr();

	  printf("\n%c EST-Projekt Funkuhr ",_1_LINE);

	  printf("\n%c  Minutenerkennung",_2_LINE );

 
while(phase_1==1)
	{       SEK=0;			//Sekunden-LED ein  
	    	del_10ms(11);           //Warte 110ms
		if(PULS_EING==0)     	//Erkenne, ob 1 oder 0 gesendet
		{	ZER_ONE=0;      //LED einschalten (log 1)
		}
		if(PULS_EING==1)
		{	ZER_ONE=1;      //LED ausschalten (log 0)
		}	
		SEK=1;	                //Sekunden_LED ausschalten
       		del_10ms(69);           //690ms warten
                TR1=1;                  //Timer 1 starten
		TIM_TICK=0;		//Timerstand auf Null setzen
    
		while(PULS_EING==1);  	//Warten auf nchsten Puls
		TR1=0;                  //Timer stoppen

		if(TIM_TICK>105)        //Minutenlcke ?
		{
			phase_1=0;      //Phase 1 vorbei
		        phase_2=1;      //Jetzt gilt Phase 2
		   	TIM_TICK=0;     //Zhlerstand auf Null setzen
													//		switch_z1();
													//	uc_Clrscr();
 printf( "\n%cLuecke erkannt!     ",_1_LINE);
 printf( "\n%c                    ",_2_LINE);
					//					 		show_text(phase_2a);  //Text in Zeile 1 schreiben
					//							switch_z2();
					//							show_text(loeschz);   //Text in Zeile 2 schreiben
			SEK_TICK=0x00;        //Sekunden-Ticker lschen
			GAP=0;                //GAP-LED ein
		}

                
	
  	}


while(phase_2==1)
    	{       SEK=0;		 	//Sekunden-LED ein 
	
	
	    	del_10ms(11);           //Warte 110ms
 		if(PULS_EING==0)     	//Erkenne, ob 1 oder 0 gesendet
		{	ZER_ONE=0;      //Datenbit-LED ein (log 1)
		}
		if(PULS_EING==1)        //Datenbit-LED aus (log 0)
		{	ZER_ONE=1;
		}
		bit_ausw(&SEK_TICK);

		SEK=1;	                //Sekunden-LED ausschalten
															
                del_10ms(69);           //690ms warten
		GAP=1;		        //LED aus
                TR1=1;                  //Timer starten
		TIM_TICK=0;		//Timerstand auf Null setzen
		
 		while((PULS_EING==1)&&(TIM_TICK<25));//Warten auf nchsten Puls
		TR1=0;                  //Timer stoppen
		TIM_TICK=0;             //Timerstand auf Null setzen
		SEK_TICK++;             //Sekunde zhlen
                bit_ausw(&SEK_TICK);    //Empfangene Bits auswerten
	      	if(PULS_EING==1)        //Ist die Minutenlcke erreicht?
		{	GAP=0;          //LED ein
			phase_2=0;      //
		        phase_3=1;      //
		     	TIM_TICK=0;     //
		        cv_ascii(&lcd_zeit[17],&SEK_TICK);

						
	 printf( "\n%cLuecke erkannt!     ",_3_LINE);
	 printf("\n%c%s", 0x00,lcd_zeit);
							//					 	

			SEK_TICK=0xff;
			cv_date(lcd_date,wochent);
		 printf("\n%c%s", 0x40,lcd_date);
				//							 	
			cv_zeit(lcd_zeit);
        	 }  
         }



while(phase_3==1)
       	{	while((PULS_EING==1)&&(TIM_TICK<25));  	//Warten auf nchsten Puls
		TR1=0;
		TIM_TICK=0;
		SEK_TICK++;
	       	cv_ascii(&lcd_zeit[17],&SEK_TICK);

		printf("\n%c%s", 0x00,lcd_zeit);

                GAP=1;                  //Lcken-LED aus

		if(PULS_EING==1)        //Ist die Minutenlcke erreicht?
		{	
                     	GAP=0;		//Lcken-LED ein

       			cv_date(lcd_date,wochent);
	   printf("\n%c%s", 0x40,lcd_date);
	
			SEK_TICK=0xff;
			cv_zeit(lcd_zeit);
		   	
		}
	       
		SEK=0;			//Sekunden-LED ein  
	    	del_10ms(11);           //Warte 110ms
 		if(PULS_EING==0)     	//Erkenne, ob 1 oder 0 gesendet
		{	ZER_ONE=0;      //Datenbit High
		}
		if(PULS_EING==1)
		{	ZER_ONE=1;      //Datenbit LOW
		}
		bit_ausw(&SEK_TICK);
	      
		SEK=1;	                //Sekunden_LED ausschalten
                del_10ms(69);           //690ms warten
		GAP=1;		        //LED aus
                TR1=1;                  //Timer starten
		TIM_TICK=0;		//Timerticker lschen
          } 
}


//*****************************************************************************

void Timer_1_ISR(void) interrupt 3       //Timer1 hat Interruptvektor 1B
{      
        TF1=0;				 //berlaufflag lschen
        TIM_TICK++;			 //Inkrementiere Timer-Tick
	TH1=0xD8;                        //Timer 1 - Reload (Oberes Byte
	TL1=0xEF + TL1;                  //Unteres Timer-Byte      
}

//----------------------------

void del_10ms(unsigned char x)
{ 	TL1=0xEF;            	//Reloadwerte fr
	TH1=0xD8;            	//10ms-Tick
	TIM_TICK=0;
	TR1=1;

	do{}
	while(TIM_TICK<x);

	TR1=0;
	TIM_TICK=0;
}

//-------------------------------

void cv_ascii(char *ptr2,char *ptr3)
{       
	char x=*ptr3;
	*ptr2=(x % 10 + 0x30);
	x=x/10;
 	ptr2--;
	*ptr2=(x  % 10 +0x30);
}

//--------------------------------

void bit_ausw(char *ptr4)
{	unsigned char x= *ptr4;

        if(x==21)
	{	if(ZER_ONE==0)
		{	MIN_EINS=MIN_EINS|0x01;
		}
		else
		{	MIN_EINS=MIN_EINS&0x0e;
		}
        }

       if(x==22)
	{	if(ZER_ONE==0)
		{	MIN_EINS=MIN_EINS|0x02;
		}
		else
		{	MIN_EINS=MIN_EINS&0x0d;
		}
        }

        if(x==23)
	{	if(ZER_ONE==0)
		{	MIN_EINS=MIN_EINS|0x04;
		}
		else
		{	MIN_EINS=MIN_EINS&0x0b;
		}
        }

        if(x==24)
	{	if(ZER_ONE==0)
		{	MIN_EINS=MIN_EINS|0x08;
		}
		else
		{	MIN_EINS=MIN_EINS&0x07;
		}
                MIN_EINS=(MIN_EINS&0x0f) + 48;
         }
       if(x==25)
	{	if(ZER_ONE==0)
		{	MIN_ZEHN=MIN_ZEHN|0x01;
		}
		else
		{	MIN_ZEHN=MIN_ZEHN&0x0e;
		}
        }

        if(x==26)
	{	if(ZER_ONE==0)
		{	MIN_ZEHN=MIN_ZEHN|0x02;
		}
		else
		{	MIN_ZEHN=MIN_ZEHN&0x0d;
		}
        }

        if(x==27)
	{	if(ZER_ONE==0)
		{	MIN_ZEHN=MIN_ZEHN|0x04;
		}
		else
		{	MIN_ZEHN=MIN_ZEHN&0x0b;
		}
                MIN_ZEHN=(MIN_ZEHN&0x07) + 48;
         }         

	if(x==29)
	{	if(ZER_ONE==0)
		{	STD_EINS=STD_EINS|0x01;
		}
		else
		{	STD_EINS=STD_EINS&0x0e;
		}
        }

       if(x==30)
	{	if(ZER_ONE==0)
		{	STD_EINS=STD_EINS|0x02;
		}
		else
		{	STD_EINS=STD_EINS&0x0d;
		}
        }

        if(x==31)
	{	if(ZER_ONE==0)
		{	STD_EINS=STD_EINS|0x04;
		}
		else
		{	STD_EINS=STD_EINS&0x0b;
		}
        }

        if(x==32)
	{	if(ZER_ONE==0)
		{	STD_EINS=STD_EINS|0x08;
		}
		else
		{	STD_EINS=STD_EINS&0xf7;
		}
                STD_EINS=(STD_EINS&0x0f) + 48;
         }
       if(x==33)
	{	if(ZER_ONE==0)
		{	STD_ZEHN=STD_ZEHN|0x01;
		}
		else
		{	STD_ZEHN=STD_ZEHN&0x0e;
		}
        }

        if(x==34)
	{	if(ZER_ONE==0)
		{	STD_ZEHN=STD_ZEHN|0x02;
		}
		else
		{	STD_ZEHN=STD_ZEHN&0x0d;
		}      
	 	STD_ZEHN=(STD_ZEHN&0x03) + 48;
        }

	if(x==36)
	{	if(ZER_ONE==0)
		{	TAG_EINS=TAG_EINS|0x01;
		}
		else
		{	TAG_EINS=TAG_EINS&0x0e;
		}
        }

       if(x==37)
	{	if(ZER_ONE==0)
		{	TAG_EINS=TAG_EINS|0x02;
		}
		else
		{	TAG_EINS=TAG_EINS&0x0d;
		}
        }

        if(x==38)
	{	if(ZER_ONE==0)
		{	TAG_EINS=TAG_EINS|0x04;
		}
		else
		{	TAG_EINS=TAG_EINS&0x0b;
		}
        }

        if(x==39)
	{	if(ZER_ONE==0)
		{	TAG_EINS=TAG_EINS|0x08;
		}
		else
		{	TAG_EINS=TAG_EINS&0x07;
		}
                TAG_EINS=(TAG_EINS&0x0f) + 48;
         }

	if(x==40)
	{	if(ZER_ONE==0)
		{	TAG_ZEHN=TAG_ZEHN|0x01;
		}
		else
		{	TAG_ZEHN=TAG_ZEHN&0x0e;
		}
        }

       if(x==41)
	{	if(ZER_ONE==0)
		{	TAG_ZEHN=TAG_ZEHN|0x02;
		}
		else
		{	TAG_ZEHN=TAG_ZEHN&0x0d;
		}                   
		TAG_ZEHN=(TAG_ZEHN&0x03) + 48;
        }

        if(x==42)
	{	if(ZER_ONE==0)
		{	WOCH_TAG=WOCH_TAG|0x01;
		}
		else
		{	WOCH_TAG=WOCH_TAG&0x0e;
		}
        }

       if(x==43)
	{	if(ZER_ONE==0)
		{	WOCH_TAG=WOCH_TAG|0x02;
		}
		else
		{	WOCH_TAG=WOCH_TAG&0x0d;
		}
        }

        if(x==44)
	{	if(ZER_ONE==0)
		{	WOCH_TAG=WOCH_TAG|0x04;
		}
		else
		{	WOCH_TAG=WOCH_TAG&0x0b;
		}
                WOCH_TAG=WOCH_TAG&0x07;
        }

	if(x==45)
	{	if(ZER_ONE==0)
		{	MON_EIN=MON_EIN|0x01;
		}
		else
		{	MON_EIN=MON_EIN&0x0e;
		}
        }

       if(x==46)
	{	if(ZER_ONE==0)
		{	MON_EIN=MON_EIN|0x02;
		}
		else
		{	MON_EIN=MON_EIN&0x0d;
		}
        }

        if(x==47)
	{	if(ZER_ONE==0)
		{	MON_EIN=MON_EIN|0x04;
		}
		else
		{	MON_EIN=MON_EIN&0x0b;
		}
        }

        if(x==48)
	{	if(ZER_ONE==0)
		{	MON_EIN=MON_EIN|0x08;
		}
		else
		{	MON_EIN=MON_EIN&0x07;
		}
                MON_EIN=(MON_EIN&0x0f) + 48;
         }

	if(x==49)
	{	if(ZER_ONE==0)
		{	MON_ZEH=MON_ZEH|0x01;
		}
		else
		{	MON_ZEH=MON_ZEH&0x0e;
		}
                MON_ZEH=(MON_ZEH&0x01) + 48;
        }

	if(x==50)
	{	if(ZER_ONE==0)
		{	JAHR_EIN=JAHR_EIN|0x01;
		}
		else
		{	JAHR_EIN=JAHR_EIN&0x0e;
		}
        }

       if(x==51)
	{	if(ZER_ONE==0)
		{	JAHR_EIN=JAHR_EIN|0x02;
		}
		else
		{	JAHR_EIN=JAHR_EIN&0x0d;
		}
        }

        if(x==52)
	{	if(ZER_ONE==0)
		{	JAHR_EIN=JAHR_EIN|0x04;
		}
		else
		{	JAHR_EIN=JAHR_EIN&0x0b;
		}
        }

        if(x==53)
	{	if(ZER_ONE==0)
		{	JAHR_EIN=JAHR_EIN|0x08;
		}
		else
		{	JAHR_EIN=JAHR_EIN&0x07;
		}
                JAHR_EIN=(JAHR_EIN&0x0f) + 48;
         }
	if(x==54)
	{	if(ZER_ONE==0)
		{	JAHR_ZEH=JAHR_ZEH|0x01;
		}
		else
		{	JAHR_ZEH=JAHR_ZEH&0x0e;
		}
        }

       if(x==55)
	{	if(ZER_ONE==0)
		{	JAHR_ZEH=JAHR_ZEH|0x02;
		}
		else
		{	JAHR_ZEH=JAHR_ZEH&0x0d;
		}
        }

        if(x==56)
	{	if(ZER_ONE==0)
		{	JAHR_ZEH=JAHR_ZEH|0x04;
		}
		else
		{	JAHR_ZEH=JAHR_ZEH&0x0b;
		}
        }

        if(x==57)
	{	if(ZER_ONE==0)
		{	JAHR_ZEH=JAHR_ZEH|0x08;
		}
		else
		{	JAHR_ZEH=JAHR_ZEH&0x07;
		}
                JAHR_ZEH=(JAHR_ZEH&0x0f) + 48;
         }

}  

//-----------------------------------------       

void cv_zeit(char *ptr5) //Adresse von lcd_zeit[0] bergeben
{	ptr5=ptr5+10;     //Stunden-Zehner-Stelle einstellen
	*ptr5=STD_ZEHN;  //Stunden-Zehner an lcd_zeit bergeben
	ptr5++;          //Stunden-Einer_Stelle einstellen
	*ptr5=STD_EINS;  //Stunden-Einer an lcd_zeit bergeben
	ptr5=ptr5 + 2;   //Minuten-Zehner_Stelle einstellen
	*ptr5=MIN_ZEHN;  //Minuten-Zehner bergeben
	ptr5++;          //Minuten-Einer-Stelle einstellen
	*ptr5=MIN_EINS;  //Minuten-Einer bergeben
}

//----------------------------------------

void cv_date(char *ptr6,char *ptr7) //lcd-date und wochent bergeben 

{	ptr6=ptr6+7;             //Wochentagsstelle einstellen
	ptr7=ptr7+2*(WOCH_TAG - 1);
	*ptr6=*ptr7;
	ptr7++;
	ptr6++;
	*ptr6=*ptr7;
	ptr6=ptr6+2;
	*ptr6=TAG_ZEHN;
	ptr6++;
	*ptr6=TAG_EINS;
	ptr6=ptr6+2;
	*ptr6=MON_ZEH;
	ptr6++;
	*ptr6=MON_EIN;
	ptr6=ptr6 + 4;
	*ptr6=JAHR_ZEH;
	ptr6++;
	*ptr6=JAHR_EIN;
}
